/**
 * @file
 * Layout Components behaviors.
 */

(function ($, Drupal, drupalSettings) {

  'use strict';

  var ajax = Drupal.ajax,
    behaviors = Drupal.behaviors;

  behaviors.customLB = {
    attach: function (context) {
      $('.js-layout-builder-block *, .block-block-content *').on('mouseenter', function(){
        if(!$(this).closest('.js-layout-builder-block, .block-block-content').hasClass('intoBlock')){
          $(this).closest('.js-layout-builder-block, .block-block-content').addClass('intoBlock');
        }
      });
      $('.js-layout-builder-block, .block-block-content').on('mouseleave', function(){
        if($(this).hasClass('intoBlock')){
          $(this).removeClass('intoBlock');
        }
      });

    }
  }
  $('.js-layout-builder-region').each(function(){
    let $configRegion = $(this).children('.layout-builder__configure-column')
    $(this).prepend($configRegion);
  });
  $('.js-layout-builder-block').each(function(){
    let $configBlock = $(this).children('.layout-builder__configure-block')
    $(this).prepend($configBlock);
  });

  let $obsevedElement=$('body');
  let observer = new MutationObserver(function(mutations) {
    mutations.forEach(function(mutation) {
      let attributeValue = $(mutation.target).prop(mutation.attributeName);
      console.log("Class attribute changed to:", attributeValue);
      $('.js-layout-builder-region').each(function(){
        let $configRegion = $(this).children('.layout-builder__configure-column')
        $(this).prepend($configRegion);
      });
      $('.js-layout-builder-block').each(function(){
        let $configBlock = $(this).children('.layout-builder__configure-block')
        $(this).prepend($configBlock);
      });
    });
  });
  observer.observe($obsevedElement[0], {
    attributes: true,
    attributeFilter: ['class']
  });
})(jQuery, Drupal, drupalSettings);
